﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;

namespace Matrices.Test
{


  /// <summary>
  ///This is a test class for MatrixArrayTest and is intended
  ///to contain all MatrixArrayTest Unit Tests
  ///</summary>
  [TestClass()]
  public class MatrixArrayTest
  {


    private TestContext testContextInstance;

    /// <summary>
    ///Gets or sets the test context which provides
    ///information about and functionality for the current test run.
    ///</summary>
    public TestContext TestContext
    {
      get
      {
        return testContextInstance;
      }
      set
      {
        testContextInstance = value;
      }
    }

    #region Additional test attributes
    // 
    //You can use the following additional attributes as you write your tests:
    //
    //Use ClassInitialize to run code before running the first test in the class
    //[ClassInitialize()]
    //public static void MyClassInitialize(TestContext testContext)
    //{
    //}
    //
    //Use ClassCleanup to run code after all tests in a class have run
    //[ClassCleanup()]
    //public static void MyClassCleanup()
    //{
    //}
    //
    //Use TestInitialize to run code before running each test
    //[TestInitialize()]
    //public void MyTestInitialize()
    //{
    //}
    //
    //Use TestCleanup to run code after each test has run
    //[TestCleanup()]
    //public void MyTestCleanup()
    //{
    //}
    //
    #endregion


    [TestMethod()]
    public void addAllTestX()
    {
      var random = new Random();
      const int num = 1000;
      for (var i = 0; i < num; i++)
        addAllTest(random.Next());
    }

    /// <summary>
    ///A test for addAll
    ///</summary>
    public void addAllTest(int seed)
    {
      const int size = 10;
      Func<int, int> matrixSize = index => index;

      var random = new Random(seed);

      Func<int, bool, IMatrix> matrixGenerator = delegate(int index, bool first)
      {
        var mSize = matrixSize(index);
        if (random.Next() % 2 == 0)
        {
          var m = new FullMatrix(mSize);
          for (var i = 0; i < mSize; i++)
            for (var j = 0; j < mSize; j++)
              m[i, j] = random.Next();
          return m;
        }
        else
        {
          var m = new DiagonalMatrix(mSize);
          for (var i = 0; i < mSize; i++)
            m[i, i] = random.Next();
          return m;
        }
      };


      var array1 = new MatrixArray(size);
      var array2 = new MatrixArray(size);
      for (var i = 0; i < size; i++)
      {
        array1[i] = matrixGenerator(i, true);
        array2[i] = matrixGenerator(i, false);
      }
      var result = array1.addAll(array2);
      for (var i = 0; i < size; i++)
        for (var j = 0; j < array1[i].size; j++)
          for (var k = 0; k < array1[i].size; k++)
            Assert.AreEqual(result[i][j, k], array1[i][j, k] + array2[i][j, k]);
    }
  }
}
